# Sigma UI Framework

A bespoke UI Framework built on Aurelia for desktop business application

[![NPM version](http://img.shields.io/npm/v/sigma-ui-framework.svg?style=flat)](https://npmjs.org/package/sigma-ui-framework)
[![NPM downloads](http://img.shields.io/npm/dt/sigma-ui-framework.svg?style=flat)](https://npmjs.org/package/sigma-ui-framework)
[![Travis](https://img.shields.io/travis/sigmaframeworks/sigma-ui-framework.svg?style=flat&maxAge=2592000)](https://travis-ci.org/sigmaframeworks/sigma-ui-framework)
[![MIT License](http://img.shields.io/badge/license-MIT-blue.svg?style=flat)](LICENSE)
[![Gitter](https://img.shields.io/badge/gitter-join_chat-red.svg?style=flat)](https://gitter.im/sigma-frameworks/ui-framework)
[![Website](https://img.shields.io/badge/visit-website-orange.svg?style=flat)](http://sigmaframeworks.io)


**[Demo](http://demo-v2.sigmaframeworks.io/)**

## Changes
* Updating custom elements to have inline views to compensate for aurelia-cli' inability to include custom-element markup.
* Making components more customizable rather than have a rigid structure and layouts

---

### Browser Support

|  |![Safari](images/browsers/safari.png)|![Chrome](images/browsers/chrome.png)|![Opera](images/browsers/opera.png)|![Firefox](images/browsers/firefox.png)|![Edge](images/browsers/edge.png)|![IE11](images/browsers/ie.png)|
|---|:---:|:---:|:---:|:---:|:---:|:---:|
|Font Glyphs|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Untested](images/browsers/error.png)|
|Responsive Grid|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Untested](images/browsers/warning.png)|
|Page Layouts|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Untested](images/browsers/warning.png)|
||
|Text Input|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|
|List Input|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|
|Tag Input|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Error](images/browsers/error.png)|
|Date Input|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Error](images/browsers/error.png)|
|Option Input|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|
|Buttons|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|
|Markdown Editor|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Untested](images/browsers/warning.png)|
||
|Menus|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|
|Panels|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|
|Dialogs|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Error](images/browsers/error.png)|
|Drawers|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|
|Tab Panels|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|
|Datagrid|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|
|Tree Panels|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|![Working](images/browsers/success.png)|


### Dependencies

* ##### Aurelia (http://aurelia.io)
  * aurelia-bootstrapper
  * aurelia-event-aggregator
  * aurelia-fetch-client
  * aurelia-framework
  * aurelia-logging
  * aurelia-metadata
  * aurelia-router
  * aurelia-templating-resources
  * aurelia-validation

* ##### Other JS Utilities
  * lodash (http://lodash.com)
  * moment (http://momentjs.com)
  * numeral (http://numeraljs.com)
  * tether (http://tether.io)
  * kramed (https://www.npmjs.com/package/kramed)

