import { FrameworkConfiguration } from 'aurelia-framework';
import 'lodash';
import 'moment';
import 'numeral';
import 'tether';
import * as ld from "lodash";
export declare var _: ld.LoDashStatic;
export declare var kramed: KramedStatic;
export declare var moment: moment.MomentStatic;
export declare var numeral: Numeral;
export * from "./utils/ui-event";
export * from "./utils/ui-format";
export * from "./utils/ui-application";
export * from "./utils/ui-constants";
export * from "./utils/ui-http-service";
export * from "./utils/ui-dialog";
export * from "./utils/ui-model";
export * from "./utils/ui-tree-model";
import "./elements/core/ui-viewport";
import "./elements/core/ui-page";
import "./elements/core/ui-grid";
import "./elements/inputs/ui-button";
import "./elements/inputs/ui-date";
import "./elements/inputs/ui-input";
import "./elements/inputs/ui-list";
import "./elements/inputs/ui-markdown";
import "./elements/inputs/ui-option";
import "./elements/components/ui-datagrid";
import "./elements/components/ui-drawer";
import "./elements/components/ui-menu";
import "./elements/components/ui-panel";
import "./elements/components/ui-tab";
import "./elements/components/ui-tree";
import './attributes/ui-marked';
import './attributes/ui-badge';
import './value-converters/ui-text';
import './value-converters/ui-lodash';
export interface UIConfig {
    title(t: string): UIConfig;
    version(t: string): UIConfig;
    appKey(t: string): UIConfig;
    apiUrl(t: string): UIConfig;
    apiHeaders(t: any): UIConfig;
    sendAuthHeader(t: boolean): UIConfig;
    languages(l: Array<any>): UIConfig;
}
export declare function configure(config: FrameworkConfiguration, configCallback: any): void;
