var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
define(["require", "exports", 'aurelia-framework', "lodash"], function (require, exports, aurelia_framework_1, _) {
    "use strict";
    var UITreeModel = (function () {
        function UITreeModel(level, maxLevels, checkLevel, model, parent) {
            var _this = this;
            this.children = [];
            this.parent = null;
            this.isVisible = true;
            this.__checkLevel = 0;
            this.id = model.id;
            this.text = model.name || model.text;
            this.level = level;
            this.icon = model.icon;
            this.root = level == -1;
            this.leaf = (model.children || []).length == 0 || level == maxLevels;
            this.active = model.active || false;
            this.expanded = model.expanded || false;
            this.checked = model.checked ? 1 : 0;
            this.parent = parent;
            this.__checkLevel = checkLevel;
            if (level < maxLevels && (model.children || []).length > 0) {
                _.each(model.children, function (m) {
                    _this.children.push(new UITreeModel(level + 1, maxLevels, checkLevel, m, _this));
                });
            }
            this.updatePartial();
        }
        Object.defineProperty(UITreeModel.prototype, "isChecked", {
            set: function (v) {
                this.checked = v = v ? 1 : 0;
                _.forEach(this.children, function (c) {
                    c.updateChild(v);
                });
                if (this.parent && this.level > this.__checkLevel) {
                    this.parent.updatePartial();
                }
            },
            enumerable: true,
            configurable: true
        });
        UITreeModel.prototype.updateChild = function (v) {
            this.checked = v;
            _.forEach(this.children, function (c) {
                c.updateChild(v);
            });
        };
        UITreeModel.prototype.updatePartial = function () {
            if (this.children && this.children.length > 0) {
                var c = _.countBy(this.children, 'checked');
                var v = 2;
                if (!c[1] && !c[2]) {
                    v = 0;
                }
                if (!c[0] && !c[2]) {
                    v = 1;
                }
                this.checked = v;
            }
            if (this.parent && this.level > this.__checkLevel) {
                this.parent.updatePartial();
            }
        };
        Object.defineProperty(UITreeModel.prototype, "isLeaf", {
            get: function () {
                return this.leaf && !this.icon;
            },
            enumerable: true,
            configurable: true
        });
        __decorate([
            aurelia_framework_1.computedFrom('leaf', 'icon'), 
            __metadata('design:type', Object)
        ], UITreeModel.prototype, "isLeaf", null);
        return UITreeModel;
    }());
    exports.UITreeModel = UITreeModel;
    var UITreeOptions = (function () {
        function UITreeOptions(obj) {
            if (obj === void 0) { obj = {}; }
            this.maxLevels = 99;
            this.showCheckbox = false;
            this.checkboxLevel = -1;
            this.showRoot = false;
            this.rootLabel = 'Root';
            this.selectionLevel = -1;
            Object.assign(this, obj);
        }
        return UITreeOptions;
    }());
    exports.UITreeOptions = UITreeOptions;
});
