// 
// @description : 
// @author      : Adarsh Pastakia
// @copyright   : 2016
// @license     : MIT

import {autoinject} from "aurelia-framework";
@autoinject()
export class Colors {

  optVal = 1;
  colors = {
    'Black/White': {
      '$black-sp': '#231F20',
      '$black': '#322E2D',
      '$white': '#FEFEFF',
      '$white-sp': '#FFFFFF'
    },

    'Cool Gray': {
      '$cg-00': '#E6EEF2',
      '$cg-0': '#DEE8ED',
      '$cg-1': '#DAE4E9',
      '$cg-2': '#CCD8DF',
      '$cg-3': '#BFCAD3',
      '$cg-4': '#A8B4BE',
      '$cg-5': '#93A0AB',
      '$cg-6': '#7E8C97',
      '$cg-7': '#647179',
      '$cg-8': '#525D65',
      '$cg-9': '#3C474E',
      '$cg-10': '#222B33'
    },

    'Warm Gray': {
      '$wg-00': '#F4F2EB',
      '$wg-0': '#EEEDE4',
      '$wg-1': '#E9E9E0',
      '$wg-2': '#DFDED6',
      '$wg-3': '#D4D4CC',
      '$wg-4': '#BFBFB8',
      '$wg-5': '#AAAAA4',
      '$wg-6': '#949690',
      '$wg-7': '#787974',
      '$wg-8': '#636360',
      '$wg-9': '#4D4D49',
      '$wg-10': '#32312E'
    },

    'Toner Gray': {
      '$tg-0': '#EDEDEE',
      '$tg-1': '#EBEBE9',
      '$tg-2': '#E1E3DF',
      '$tg-3': '#D4D4CE',
      '$tg-4': '#BDBDBA',
      '$tg-5': '#AAA8A4',
      '$tg-6': '#959491',
      '$tg-7': '#777774',
      '$tg-8': '#646261',
      '$tg-9': '#4E4C4A',
      '$tg-10': '#32312F'
    },

    'Neutral Gray': {
      '$ng-0': '#EDEDEE',
      '$ng-1': '#E3E5E6',
      '$ng-2': '#DCDDDE',
      '$ng-3': '#D3D5D6',
      '$ng-4': '#BDC0C2',
      '$ng-5': '#A9AAAD',
      '$ng-6': '#949699',
      '$ng-7': '#78797D',
      '$ng-8': '#646467',
      '$ng-9': '#4E4E50',
      '$ng-10': '#333233'
    },

    'Earth Tones': {
      '$floral-white': '#FEF9F3',
      '$pale-fruit': '#FEF4ED',
      '$skin-white': '#FDF2E9',
      '$pink-flamingo': '#FDEEE3',
      '$fruit-pink': '#FDEDE0',
      '$eggshell': '#F3EBEE',
      '$bisque': '#F9EDD5',
      '$brick-white': '#F5E9DB',
      '$pearl-white': '#FDF0E3',
      '$barley-beige': '#FDEBD7',
      '$sand-white': '#F4E8D7',
      '$dull-ivory': '#EADCBE',
      '$ash-rose': '#F2EAE6',
      '$champagne': '#E4D9D5',
      '$milky-white': '#FDECD7',
      '$raw-silk': '#F4E5C1',
      '$light-camel': '#F1DCB8',
      '$ivory': '#F0E6C1',
      '$brick-beige': '#F3E4CC',
      '$lipstick-natural': '#E3BDC4',
      '$light-suntan': '#E6C5AF',
      '$baby-skin': '#FFE4C9',
      '$sand': '#F3CFB0',
      '$hazelnut': '#ECC9B1',
      '$orientale': '#F1C9A7',
      '$chamois': '#E8C6A4',
      '$clay': '#C6BAA9',
      '$tea-rose': '#FCD4BA',
      '$caribe-cocoa': '#D4A483',
      '$khaki': '#AC9F7F',
      '$cocoa-brown': '#A3857D',
      '$walnut': '#9B806D',
      '$africano': '#997664',
      '$dark-brown': '#8B6F5B',
      '$maroon': '#805F4E',
      '$fig': '#71614F',
      '$pecan': '#5A4A39',
      '$dark-bark': '#644D3B',
      '$copper': '#87534D',
      '$burnt-umber': '#884738',
      '$cashew': '#4C2E23',
      '$light-mahogany': '#CD816B',
      '$light-walnut': '#B5855A',
      '$flesh-pink': '#FDBF7F',
      '$sepia': '#CC915B',
      '$leather': '#CA753F',
      '$reddish-brass': '#B86058',
      '$brown': '#CB6653',
      '$baked-clay': '#B66135',
      '$burnt-sienna': '#D76950',
      '$redwood': '#C6533A'
    },

    'Violet': {
      '$rose-quartz': '#F1EDF6',
      '$pale-heath': '#EAE5F2',
      '$heath': '#E6C2D9',
      '$pale-lilac': '#ECD7EA',
      '$lilac': '#E5ABCE',
      '$pale-grape': '#E9C7D1',
      '$early-grape': '#E5C2DE',
      '$marigold': '#E2A6CC',
      '$mallow': '#D3A8CE',
      '$lavender': '#CF96C5',
      '$light-grape': '#B87EA7',
      '$violet': '#8955A4',
      '$wisteria': '#DFDEED',
      '$ash-lavender': '#B3B0D0',
      '$amethyst': '#A192C9',
      '$pale-blackberry': '#8680AD',
      '$eggplant': '#6D658D',
      '$aubergine': '#534259'
    },

    'Blue Violet': {
      '$plain-thistle': '#E9E7F4',
      '$iridescent-mauve': '#E7E0EF',
      '$mauve-shadow': '#E2DDEF',
      '$viola': '#C8C9E7',
      '$prune': '#ABB9DD',
      '$blue-violet': '#A080BB',
      '$hydrangea-blue': '#8591C9',
      '$blueberry': '#7E97CE',
      '$reddish-blue': '#7084BD',
      '$clematis': '#6989C7',
      '$soft-violet': '#D5D3EC',
      '$pale-lavender': '#DDE2F4',
      '$dull-lavender': '#D1DCF1',
      '$grayish-lavender': '#B1C2DD',
      '$bluebell': '#A1A8C0',
      '$grayish-violet': '#8182A6',
      '$slate': '#3A4558'
    },

    'Blue': {
      '$pale-celestine': '#F1FAFE',
      '$porcelain-blue': '#F0F9F9',
      '$pale-blue': '#E4EEF4',
      '$powder-blue': '#E3EFFB',
      '$frost-blue': '#DFF2F3',
      '$baby-blue': '#DFEEFB',
      '$blue-gray': '#DBE2F3',
      '$grayish-blue': '#D7E3EA',
      '$mint-blue': '#D6EFF1',
      '$ice-blue': '#C9E6EF',
      '$aqua-blue': '#C8E6FA',
      '$robin-egg': '#B4E4F0',
      '$greenish-blue': '#AFCDDE',
      '$hydrangea': '#A8BCE2',
      '$crockery-blue': '#96C5DD',
      '$tahiti-blue': '#74CFE8',
      '$smoky-blue': '#75C2ED',
      '$light-blue': '#72D0EE',
      '$process-blue': '#42C8E7',
      '$peacock-blue': '#00B3E6',
      '$cyanine-blue': '#00BEEB',
      '$manganese-blue': '#81C5ED',
      '$phthalo-blue': '#93C4EC',
      '$skyblue': '#8ACFF3',
      '$cobalt-blue': '#67B3E4',
      '$lapis-lazuli': '#0B8BCB',
      '$royal-blue': '#1E6DB7',
      '$ultramarine': '#0077C2',
      '$antwerp-blue': '#0F70A5',
      '$prussian-blue': '#2D63AA',
      '$stratosphere-blue': '#1B65AF',
      '$iris': '#3D489E',
      '$night-blue': '#477C9B',
      '$agate': '#0E5480'
    },

    'Blue Green': {
      '$snow-green': '#EFF8F2',
      '$pale-aqua': '#E8F5EE',
      '$new-blue': '#C8EAEB',
      '$holiday-blue': '#84D4E5',
      '$petroleum-blue': '#00B6CE',
      '$blue-green': '#00B0CA',
      '$cool-shadow': '#E1F2EF',
      '$moon-white': '#CFEDF0',
      '$mint-green': '#C5E9EB',
      '$aqua': '#A3DBD3',
      '$teal-blue': '#41C1B0',
      '$coral-sea': '#C0E5DD',
      '$aqua-mint': '#BFE3D7',
      '$horizon-green': '#A4DCD8',
      '$nile-blue': '#B2E1E1',
      '$duck-blue': '#00B7BA',
      '$ice-mint': '#AECFD1',
      '$jasper': '#66BFC0',
      '$ocean-mist': '#DDEBED',
      '$ice-ocean': '#77B9BE',
      '$abyss-green': '#5A928F',
      '$bronze': '#49706A',
      '$gray-sky': '#E6EAE4',
      '$green-gray': '#BBC2B8',
      '$bush': '#83A292',
      '$flagstone-blue': '#6F9D89'
    },

    'Green': {
      '$crystal-opal': '#F1F9F3',
      '$wax-white': '#EDF5DC',
      '$pale-green': '#EBF5EE',
      '$jade-green': '#E6F3EE',
      '$dim-green': '#E6F2E0',
      '$pistachio': '#DAE9A9',
      '$sea-green': '#D5EAC7',
      '$spectrum-green': '#D0E9D4',
      '$spring-green': '#CEDCBB',
      '$lime-green': '#C6E6CE',
      '$willow': '#C4E2B5',
      '$meadow-green': '#B6DC9C',
      '$emerald-green': '#69C37C',
      '$nile-green': '#7DC779',
      '$veronese-green': '#7DC666',
      '$grass-green': '#71C357',
      '$apple-green': '#97D092',
      '$malachite': '#60C399',
      '$forest-green': '#00B480',
      '$parrot-green': '#36BA8B',
      '$ocean-green': '#009463',
      '$pinetree-green': '#1F7D5D',
      '$mistletoe': '#599F75',
      '$verdigris': '#9FC6AA',
      '$greyish-olive': '#98A686',
      '$olive': '#5F803A'
    },

    'Yellow Green': {
      '$lily-white': '#F3F7E0',
      '$mimosa-yellow': '#F3F7E0',
      '$green-bice': '#E5EEB2',
      '$yellow-green': '#E2ECAB',
      '$pale-moss': '#D8E8D6',
      '$pale-cobalt-green': '#D7ECD5',
      '$salad': '#D9E794',
      '$yellowish-green': '#C6E092',
      '$acid-green': '#A7D04E',
      '$lettuce-green': '#82C766',
      '$mignonette': '#E6F1D1',
      '$chartreuse': '#D5E7A0',
      '$anise': '#F9F6BE',
      '$new-leaf': '#E9ED91',
      '$celadon-green': '#D1E37E',
      '$cobalt-green': '#B5DEB9',
      '$pea-green': '#A3CBA3',
      '$moss': '#80C08B',
      '$putty': '#DCD8B0',
      '$grayish-yellow': '#D4D49E',
      '$pale-olive': '#CAC85E',
      '$spanish-olive': '#929002',
      '$marine-green': '#4E6B14'
    },

    'Yellow': {
      '$fluorite': '#FFFEF4',
      '$pale-lemon': '#FFFDEB',
      '$barium-yellow': '#FFFCE2',
      '$pale-yellow': '#FFFCCE',
      '$canary-yellow': '#FAF398',
      '$acacia': '#F0E555',
      '$yellow': '#FDF66E',
      '$acid-yellow': '#FEF303',
      '$lemon-yellow': '#FCF7AF',
      '$cadmium-yellow': '#FEE96E',
      '$golden-yellow': '#FFE456',
      '$lightning-yellow': '#FEEE56',
      '$napoli-yellow': '#FEEA41',
      '$buttercup-yellow': '#FDEEC1',
      '$yellowish-beige': '#FEE5B6',
      '$mustard': '#F2DB68',
      '$lionet-gold': '#CAA96B',
      '$cashmere': '#F9DFC3',
      '$maize': '#FED97A',
      '$honey': '#FED474'
    },

    'Yellow Red': {
      '$pale-chiffon': '#FDF2E6',
      '$silk': '#FDECD9',
      '$macadamia-nut': '#FDF1DB',
      '$yellowish-shade': '#FFE2C2',
      '$cream': '#F5DEB2',
      '$light-orange': '#FFDEC9',
      '$powder-pink': '#FDD8C0',
      '$peach-puff': '#FDDCC3',
      '$skin-pink': '#FDDCC6',
      '$reddish-yellow': '#FFE0A8',
      '$loquat': '#FFE3A6',
      '$yellow-ochre': '#EECF8B',
      '$pale-sepia': '#F2D063',
      '$caramel': '#FECA4F',
      '$chrome-orange': '#FEC669',
      '$apricot': '#FEB928',
      '$mellow-peach': '#FDC98E',
      '$pumpkin-yellow': '#FDB785',
      '$atoll': '#FCAE60',
      '$cadmium-orange': '#F4713B',
      '$sanguine': '#F46D3B',
      '$orange': '#F47023',
      '$tuscan-orange': '#D66738',
      '$chinese-orange': '#F25721'
    },

    'Red': {
      '$pink-beryl': '#FDF2EE',
      '$cherry-white': '#FDEEE8',
      '$pinkish-white': '#FDEBE0',
      '$yellowish-pink': '#FFE5DF',
      '$pinkish-vanilla': '#FEE3DA',
      '$cherry-pink': '#FEE3D5',
      '$blush': '#FDD9D1',
      '$flesh': '#FCD5C8',
      '$light-tea-rose': '#FCD5C3',
      '$sardonyx': '#FCC3B9',
      '$peach': '#FCC4BC',
      '$light-prawn': '#FAB8B3',
      '$light-rouse': '#F89D93',
      '$salmon-red': '#F8927E',
      '$bougainvillea': '#EE838F',
      '$lipstick-orange': '#F8856B',
      '$prawn': '#F4767C',
      '$coral': '#F47283',
      '$carmine': '#E76D75',
      '$vermilion': '#F46656',
      '$cadmium-red': '#F15162',
      '$lipstick-red': '#EF184C',
      '$strong-red': '#E04E69',
      '$dark-red': '#7E2B41',
      '$garnet': '#CA4A7B',
      '$cardinal': '#B95171',
      '$rose-red': '#D36893',
      '$currant': '#D17E96',
      '$rose-mist': '#F19CB8',
      '$rose-pink': '#F1CAD3'
    },

    'Red Violet': {
      '$evening-primrose': '#F2EAF4',
      '$pale-purple': '#F4E3EF',
      '$pale-pink': '#FDEDF4',
      '$water-lily': '#F0DAEB',
      '$almond-pink': '#FBD7E7',
      '$light-pink': '#FDEAE9',
      '$grayish-cherry': '#E3D2E2',
      '$pink': '#FCD8DD',
      '$shadow-pink': '#FCD5CF',
      '$tender-pink': '#FCCAD8',
      '$cotton-candy': '#FBC9DF',
      '$pure-pink': '#FABCC9',
      '$salmon-pink': '#FBBDB7',
      '$dark-pink': '#FBB0AF',
      '$smoky-purple': '#E8B6CA',
      '$hollyhock': '#EAA7CC',
      '$begonia': '#D19DAC',
      '$shock-pink': '#F7A5C0',
      '$rose-flower': '#F695C0',
      '$begonia-pink': '#F695B6',
      '$cerise': '#F586AF',
      '$deep-magenta': '#DD7FB4',
      '$fuchsia': '#E172AD',
      '$red-violet': '#D46AAA',
      '$crimson': '#F0487F',
      '$baby-blossoms': '#B783A1',
      '$raspberry': '#B86B84',
      '$peony': '#8C586F',
      '$argyle-purple': '#594857'
    }
  }

}
